%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                  PSG Type    PSG Object         Location in Problem Statement                    Class
%matrix_s_benchmark      bench       matrix_s           vector_c_p75*cvar_dev(vector_a_p75, matrix_s)    double
%                                                       cvar_risk(parameter_alpha,matrix_s)
%matrix_s_data           data        matrix_s           vector_c_p75*cvar_dev(vector_a_p75, matrix_s)    double
%                                                       cvar_risk(parameter_alpha,matrix_s)
%matrix_s_vars           vars        matrix_s           vector_c_p75*cvar_dev(vector_a_p75, matrix_s)    cell
%                                                       cvar_risk(parameter_alpha,matrix_s)
%vector_a_p75_data       data        vector_a_p75       vector_c_p75*cvar_dev(vector_a_p75, matrix_s)    double
%vector_c_p75_data       data        vector_c_p75       vector_c_p75*cvar_dev(vector_a_p75, matrix_s)    double
%parameter_alpha_data    data        parameter_alpha    cvar_risk(parameter_alpha,matrix_s)              double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_s_benchmark,matrix_s_data,matrix_s_vars,vector_a_p75_data,vector_c_p75_data,parameter_alpha_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_s',matrix_s_data,matrix_s_vars,matrix_s_benchmark,[]);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_a_p75',vector_a_p75_data);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_c_p75',vector_c_p75_data);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'  vector_c_p75*cvar_dev(vector_a_p75, matrix_s)',...
'',...
'calculate',...
'Point: point_problem_1',...
'  cvar_risk(parameter_alpha,matrix_s)',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_alpha',num2str(parameter_alpha_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

